---
title: Get Window Handles
slug: Web/WebDriver/Commands/GetWindowHandles
tags:
  - Command
  - Get Window Handles
  - Reference
  - WebDriver
---
<p>The <em>Get Window Handles</em> <a href="/en-US/Web/WebDriver/Command">command</a> of the <a href="/en-US/docs/Web/WebDriver">WebDriver</a> API returns a list of all <code><a href="/en-US/docs/Web/WebDriver/WebWindow">WebWindow</a></code>s. Each tab or window, depending on whether you are using a tabbed browser, is associated by a <em>window handle</em> that is used as a reference when <a href="/en-US/docs/Web/WebDriver/Commands/SwitchToWindow">switching to the window</a>.</p>

<p>In order to determine whether or not a particular interaction with the browser opens a new window, one can obtain the set of window handles before the interaction is performed and compare it with the set after the action is performed.</p>

<h2 id="Syntax">Syntax</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Method</th>
   <th scope="col">URI template</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td><code><a href="/en-US/docs/Web/HTTP/Methods/GET">GET</a></code></td>
   <td><code>/session/{<em>session id</em>}/window/handles</code></td>
  </tr>
 </tbody>
</table>

<h3 id="URL_parameters">URL parameters</h3>

<dl>
 <dt><code>session id</code></dt>
 <dd>Identifier of the session.</dd>
</dl>

<h3 id="Errors">Errors</h3>

<dl>
 <dt>Invalid session ID</dt>
 <dd>Session does not exist.</dd>
</dl>

<h2 id="Example">Example</h2>

<p>C#:</p>

<pre class="brush: cpp">using System.Collections.ObjectModel;
using OpenQA.Selenium.Firefox;

namespace MDNWebDriverExamples
{
    class Example
    {
        public static void Main(string[] args)
        {
            FirefoxDriver session = new FirefoxDriver();

            session.ExecuteScript("window.open()");

            ReadOnlyCollection&lt;string&gt; currentWindowHandles = session.WindowHandles;
        }
    }
}

</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName("WebDriver", "#dfn-get-window-handles", "Get Window Handles")}}</td>
   <td>{{Spec2("WebDriver")}}</td>
   <td>Initial definition</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("webdriver.commands.GetWindowHandles")}}</p>

<h2 id="See_also">See also</h2>


<ul>
 <li><a href="/en-US/docs/Web/WebDriver/Commands/SwitchToWindow">Switch To Window</a> command</li>
 <li><a href="/en-US/docs/Web/WebDriver/Commands/GetWindowHandle">Get Window Handle</a> command</li>
 <li><a href="/en-US/docs/Web/WebDriver/Commands/CloseWindow">Close Window</a> command</li>
</ul>

